<?php

/**
 * @file
 * Contains \Drupal\blocache\Blocache.
 */

namespace Drupal\blocache;

/**
 * Class Blocache.
 */
class Blocache {

	/**
	 *
	 *
	 * @return 
	 * 
	 */
	public function cacheContexts() {
		$contexts = [];

	  $container = \Drupal::getContainer();
	  $services = $container->getServiceIds();

	  foreach ($services as $id) {
	    if (strpos($id, 'cache_context.') !== 0) {
	      continue;
	    }

	    $service = $container->get($id);
	    $class_name = get_class($service);
	    $class = new \ReflectionClass($class_name);
	    $parameters = $class->getMethod('getContext')->getParameters();
	    
	    $params = [];
	    foreach ($parameters as $param) {
	      $params[] = $param->name;
	    }
	    
	    $context = substr($id, 14);
	    $contexts[$context] = [
	      'id' => $context,
	      'params' => $params,
	    ];
	  }

	  return $contexts;
	}

	/**
	 *
	 *
	 * @return 
	 * 
	 */
	public function prepareContextsToStorage($values) {
		$contexts = [];

    $i = 0;
    foreach ($values as $key => $value) {
      $count = strlen('__arg');
      if ((substr($key, -$count) === '__arg')) {
        continue;
      }

      if ($value === 1) {
        $contexts[$i] = $key;
        
        if ($arg = $values[$key . '__arg']) {
          $contexts[$i] .= ':' . $arg;
        }
        $i++;
      }
    }

    return $contexts;
	}

	/**
	 *
	 *
	 * @return 
	 * 
	 */
	public function prepareContextsFromStorage($metadata) {
		$contexts = [];

	  foreach ($metadata as $key => $value) {
	    $value = explode(':', $value);
	    $contexts[$value[0]] = isset($value[1]) ? $value[1] : ''; 
	  }

    return $contexts;
	}

}